# tet

## Name

tet — A single tetrahedron in a 3-manifold triangulation

## Synopsis

Content Model

    tet ::= (#PCDATA)

Attributes
Name | Type
`desc` | CDATA

## Description

A `tet` element stores a single tetrahedron in a 3-manifold triangulation with its associated face gluings.

The character data of this XML element should be a whitespace-separated list of four integer pairs, representing the gluings of faces 0, 1, 2 and 3 of this tetrahedron. Note that face `i` is always opposite vertex `i` in a tetrahedron.

For each pair, the first integer represents the tetrahedron to which the face is glued (note that tetrahedra in a triangulation are numbered 0, 1, 2, etc.). The second integer represents the permutation of vertices from this tetrahedron to the other describing precisely how this gluing takes place. This permutation will take the current face number to the corresponding face number of the adjacent tetrahedron, and the other three vertex numbers to the corresponding three vertex numbers on the adjacent tetrahedron to which they are identified by this gluing.

A permutation is represented as a one-byte integer as follows. If the permutation maps 0, 1, 2 and 3 to `a`, `b`, `c` and `d` respectively (where `a`, `b`, `c` and `d` are 0, 1, 2 and 3 in some order), the corresponding one-byte integer is (`a` + 4`b` + 16`c` + 64`d`). For example, the identity permutation which maps (0, 1, 2, 3) to (0, 1, 2, 3) is represented by the one-byte integer (0 + 4 + 32 + 192), which is 228 (or -28 if the byte is signed).

If a face is a boundary face (i.e., it is not glued to anything), the two corresponding integers stored in the XML character data should be -1 and -1.

### Parents

The following elements contain `tet`: `tetrahedra`.

### Children

Element `tet` has no children.

## Attributes

`desc`

  A human-readable description of the role that this tetrahedron plays in the overall triangulation.

## Example

The following XML snippet represents tetrahedron 0 in a triangulation. Its faces 0 and 1 are both glued to tetrahedron 1 with a gluing permutation that maps (0, 1, 2, 3) to (2, 3, 0, 1); in particular, its face 0 is glued to face 2 of tetrahedron 1 and its face 1 is glued to face 3 of tetrahedron 1. Its faces 2 and 3 are each boundary faces.

    <tet> 1 78 1 78 -1 -1 -1 -1 </tet>